using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Guzva
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] str = Console.ReadLine().Split();
            int n = int.Parse(str[0]);
            int m = int.Parse(str[1]);
            int[,] a = new int[n, m];
            for (int i = 0; i < n; i++)
            {
                str = Console.ReadLine().Split();
                for (int j = 0; j < m; j++)
                    a[i, j] = int.Parse(str[j]);
            }
            int q = int.Parse(Console.ReadLine());
            for (int p = 0; p < q; p++)
            {
                int s = a[0, 0];
                str = Console.ReadLine().Split();
                int x = int.Parse(str[0]);
                int y = int.Parse(str[1]);
                x--;
                y--;
                int i = 0, j = 0;
                while (!(i == n - 1 && j == m - 1))
                {
                    if (i + 1 == x && j == y)
                        j++;
                    else if (j + 1 == y && i == x)
                        i++;
                    else
                    {
                        if (i == n - 1)
                            j++;
                        else if (j == m - 1)
                            i++;
                        else if (a[i + 1, j] < a[i, j + 1])
                            i++;
                        else j++;
                    }
                    s += a[i, j];
                }
                Console.WriteLine(s);
            }
        }
    }
}